"use strict";
/*
 * Copyright 2020 Fluence Labs Limited
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
__exportStar(require("./ipfs-api"), exports);
var ipfs_api_1 = require("./ipfs-api");
var fluence_1 = require("@fluencelabs/fluence");
var fluence_network_environment_1 = require("@fluencelabs/fluence-network-environment");
var _a = require('ipfs-http-client'), create = _a.create, globSource = _a.globSource, urlSource = _a.urlSource;
var all = require('it-all');
var uint8ArrayConcat = require('uint8arrays/concat');
var local = [
    {
        peerId: "12D3KooWHBG9oaVx4i3vi6c1rSBUm7MLBmyGmmbHoZ23pmjDCnvK",
        multiaddr: "/ip4/127.0.0.1/tcp/9990/ws/p2p/12D3KooWHBG9oaVx4i3vi6c1rSBUm7MLBmyGmmbHoZ23pmjDCnvK"
    },
    {
        peerId: "12D3KooWRABanQHUn28dxavN9ZS1zZghqoZVAYtFpoN7FdtoGTFv",
        multiaddr: "/ip4/127.0.0.1/tcp/9991/ws/p2p/12D3KooWRABanQHUn28dxavN9ZS1zZghqoZVAYtFpoN7FdtoGTFv"
    },
    {
        peerId: "12D3KooWFpQ7LHxcC9FEBUh3k4nSCC12jBhijJv3gJbi7wsNYzJ5",
        multiaddr: "/ip4/127.0.0.1/tcp/9992/ws/p2p/12D3KooWFpQ7LHxcC9FEBUh3k4nSCC12jBhijJv3gJbi7wsNYzJ5"
    },
];
function main(environment) {
    var e_1, _a;
    return __awaiter(this, void 0, void 0, function () {
        var fluence, ipfsAddr, ipfsMultiaddr, ipfs, source, file, files, files_1, files_1_1, file_1, content, _b, e_1_1, getResult, putResult;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, fluence_1.createClient(environment[1])];
                case 1:
                    fluence = _c.sent();
                    console.log("📗 created a fluence client %s with relay %s", fluence.selfPeerId, fluence.relayPeerId);
                    ipfsAddr = 'https://stage.fluence.dev:15001';
                    ipfsMultiaddr = '/ip4/134.209.186.43/tcp/5001/p2p/12D3KooWEhCqQ9NBnmtSfNeXSNfhgccmH86xodkCUxZNEXab6pkw';
                    ipfs = create(ipfsAddr);
                    console.log("📗 created ipfs client");
                    return [4 /*yield*/, ipfs.id()];
                case 2:
                    _c.sent();
                    console.log("📗 connected to ipfs");
                    source = urlSource('https://images.adsttc.com/media/images/5ecd/d4ac/b357/65c6/7300/009d/large_jpg/02C.jpg?1590547607');
                    return [4 /*yield*/, ipfs.add(source)];
                case 3:
                    file = _c.sent();
                    console.log("📗 uploaded file:", file);
                    return [4 /*yield*/, ipfs.get(file.cid)];
                case 4:
                    files = _c.sent();
                    _c.label = 5;
                case 5:
                    _c.trys.push([5, 11, 12, 17]);
                    files_1 = __asyncValues(files);
                    _c.label = 6;
                case 6: return [4 /*yield*/, files_1.next()];
                case 7:
                    if (!(files_1_1 = _c.sent(), !files_1_1.done)) return [3 /*break*/, 10];
                    file_1 = files_1_1.value;
                    _b = uint8ArrayConcat;
                    return [4 /*yield*/, all(file_1.content)];
                case 8:
                    content = _b.apply(void 0, [_c.sent()]);
                    console.log("📗 downloaded file of length ", content.length);
                    _c.label = 9;
                case 9: return [3 /*break*/, 6];
                case 10: return [3 /*break*/, 17];
                case 11:
                    e_1_1 = _c.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 17];
                case 12:
                    _c.trys.push([12, , 15, 16]);
                    if (!(files_1_1 && !files_1_1.done && (_a = files_1.return))) return [3 /*break*/, 14];
                    return [4 /*yield*/, _a.call(files_1)];
                case 13:
                    _c.sent();
                    _c.label = 14;
                case 14: return [3 /*break*/, 16];
                case 15:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 16: return [7 /*endfinally*/];
                case 17: 
                // default IPFS timeout is 1 sec, set to 10 secs to retrieve file from remote node
                return [4 /*yield*/, ipfs_api_1.set_timeout(fluence, environment[2].peerId, 10)];
                case 18:
                    // default IPFS timeout is 1 sec, set to 10 secs to retrieve file from remote node
                    _c.sent();
                    console.log("📘 file hash: ", file.cid);
                    return [4 /*yield*/, ipfs_api_1.get_from(fluence, environment[2].peerId, file.cid.toString(), ipfsMultiaddr, { ttl: 10000 })];
                case 19:
                    getResult = _c.sent();
                    console.log("📘 Ipfs.get", getResult);
                    return [4 /*yield*/, ipfs_api_1.put(fluence, environment[2].peerId, getResult.path, { ttl: 10000 })];
                case 20:
                    putResult = _c.sent();
                    console.log("📘 Ipfs.put", putResult);
                    return [2 /*return*/];
            }
        });
    });
}
var args = process.argv.slice(2);
var environment;
if (args.length >= 1 && args[0] == "local") {
    environment = local;
    console.log("📘 Will connect to local nodes");
}
else {
    environment = fluence_network_environment_1.testNet;
    console.log("📘 Will connect to testNet");
}
main(environment)
    .then(function () { return process.exit(0); })
    .catch(function (error) {
    console.error(error);
    process.exit(1);
});
